package com.uca.dao;

import com.uca.entity.GommetteEntity;

import java.sql.*;
import java.util.ArrayList;

public class GommetteDAO extends _Generic<GommetteEntity> {

    public GommetteEntity extract(ResultSet resultSet)
    {
        try {
            if (resultSet.next()) 
            {
                GommetteEntity entity = new GommetteEntity();
                entity.setId(resultSet.getInt("id"));
                // entity.setCouleur TODO
                entity.setNom(resultSet.getString("nom"));
                entity.setDescription(resultSet.getString("description"));
                return entity;
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return null;
    }

    public ArrayList<GommetteEntity> getAll() { return getAllGommettes(); }
    public ArrayList<GommetteEntity> getAllGommettes() {
        ArrayList<GommetteEntity> entities = new ArrayList<>();
        try {
            PreparedStatement preparedStatement = this.connect
                    .prepareStatement("SELECT * FROM gommettes ORDER BY id ASC;");
            ResultSet resultSet = preparedStatement.executeQuery();
            
            while(true)
            {
                GommetteEntity entity = extract(resultSet);
                if(entity == null) { return entities;}
                entities.add(entity);
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }

        return entities;
    }

    @Override
    public GommetteEntity create(GommetteEntity obj) {
        try {
            PreparedStatement stmt = this.connect.prepareStatement("insert into gommettes (id, nom, description) values (?, ?, ?);");
            int idx = 1;
            stmt.setInt   (idx++, obj.getId());
            stmt.setString(idx++, obj.getNom());
            stmt.setString(idx++, obj.getDescription());
            ResultSet rs = stmt.executeQuery() ;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return obj;
    }

    public GommetteEntity getById(int id)
    {
        GommetteEntity entity = null;
        try {
            PreparedStatement stmt = this.connect.prepareStatement("SELECT * FROM gommettes where id = ?;");
            stmt.setInt(1, id);
            return extract(stmt.executeQuery());
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return entity;
    }

    @Override
    public void delete(GommetteEntity obj) {
        delete(obj.getId());
    }

    public void delete(int id) {
        try {
            PreparedStatement stmt = this.connect.prepareStatement("DELETE FROM gommettes WHERE id = ?;");
            stmt.setInt   (1, id);
            ResultSet rs = stmt.executeQuery() ;
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
}
